POJ3126 Prime Path【BFS】

Prime Path

Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 28470   Accepted: 15534

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 

1033
1733
3733
3739
3779
8779
8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

Source

Northwestern Europe 2006

问题链接:POJ3126 Prime Path

问题描述:给定两个四位素数a  b,要求把a变换到b。变换的过程要保证每次变换出来的数都是一个 四位素数,而且当前这步的变换所得的素数 与 前一步得到的素数只能有一个位不同,而且每步得到的素数都不能重复。求从a到b最少需要的变换次数。无法变换则输出Impossible

解题思路:先打表计算四位数的素数,每次改变当前数的某一位,BFS,细节看代码

AC的C++代码:

#include<iostream>
#include<string>
#include<cstring>
#include<queue>

using namespace std;

const int N=10005;
bool prime[N+1];
bool vis[N];

void maketable(int n)
{
	prime[0]=prime[1]=true;
	for(int i=2;i<=n;i++)
	  if(!prime[i]){
	  	for(int j=i+i;j<=n;j+=i)
	  	  prime[j]=true;
	  }
}

struct Node{
	string v;
	int step;
	Node(){}
	Node(string v,int step):v(v),step(step){}
};

int getval(string s)
{
	int ans=0;
	for(int i=0;i<s.length();i++)
	  ans=ans*10+s[i]-'0';
	return ans;
}

int bfs(string s,string en)
{
	memset(vis,false,sizeof(vis));
	int v=getval(s);
	vis[v]=true;
	queue<Node>q;
	q.push(Node(s,0));
	while(!q.empty()){
		Node f=q.front();
		if(en==f.v)
		  return f.step;
		q.pop();
		for(int i=0;i<4;i++){
			int st=(i==0)?1:0;
			for(int j=st;j<=9;j++){
				string str=f.v;
				str[i]=j+'0';
				int val=getval(str);
				if(!vis[val]&&!prime[val]){//如果这个数是素数且没被访问 
					vis[val]=true;//标记这个数被访问了 
					q.push(Node(str,f.step+1));
				}
			}
		}
	}
	return -1;//不存在就返回-1 
}

int main()
{
	int t;
	string s,en;
	cin>>t;
	maketable(N);
	while(t--){
		cin>>s>>en;
		int ans=bfs(s,en);
		if(ans==-1)
		  cout<<"Impossible"<<endl;
		else
		  cout<<ans<<endl;
	}
	return 0;
}

 

猜你喜欢

转载自blog.csdn.net/SongBai1997/article/details/82873608
今日推荐